<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css"
        integrity="sha512-iecdLmaskl7CVkqkXNQ/ZH/XLlvWZOJyj7Yy7tcenmpD1ypASozpmT/E0iPtmFIB46ZmdtAc9eNBvH0H/ZpiBw=="
        crossorigin="anonymous" referrerpolicy="no-referrer" />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import DataTable Library -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.25/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.25/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.25/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <div class="container-fluid">
        <div class="text-center mt-2 mb-2">
            <h2>F200 - Lịch sử Voucher</h2>
        </div>
        <div class="jumbotron container">
            <div class="row form-group mb-0">
                <div class="col-sm-4">
                    <label>UserName</label>
                    <input class="form-control bg-secondary text-white" type="text" name="" id="inp-username" disabled>
                </div>
                <div class="col-sm-4">
                    <label>FirstName</label>
                    <input class="form-control bg-secondary text-white" type="text" name="" id="inp-firstname" disabled>

                    </select>
                </div>
                <div class="col-sm-4">
                    <label>Lastname</label>
                    <input class="form-control bg-secondary text-white" type="text" name="" id="inp-lastname" disabled>
                </div>
            </div>
        </div>

        <div class="container">
            <table class="table table-bordered table-striped table-hover" id="voucher-table">
                <thead class="thead-dark">
                    <tr>
                        <th>STT</th>
                        <th>Mã voucher</th>
                        <th>Phần trăm giảm giá</th>
                        <th>Ngày tạo</th>
                    </tr>
                </thead>
            </table>
        </div>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const baseUrl = "http://203.171.20.210:8080/devcamp-lucky-dice";
    var gVoucherInfoOjb = {}
    var gVoucherHistory = []

    var gName_Col = ["stt", "maVoucher", "phanTramGiamGia" , "ngayTao"]
    const gCOL_STT = 0;
    const gCOL_DICE = 1;
    const gCOL_DISCOUNT = 2;
    const gCOL_DATE = 3;

    var gDataTable = $("#voucher-table").DataTable({
        columns: [
            { data: gName_Col[gCOL_STT] },
            { data: gName_Col[gCOL_DICE] },
            { data: gName_Col[gCOL_DISCOUNT] },
            { data: gName_Col[gCOL_DATE] },

        ],
        columnDefs: [
            {
                targets: gCOL_STT,
                class: "text-primary text-center",
                render: function (data, type, row, meta) {
                    
                    return meta.row + meta.settings._iDisplayStart + 1;
                }
            },
            {
                targets: gCOL_DICE,
                class: "text-center"
            }
        ]
    })
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */

    $(document).ready(function () {
        onPageLoading()
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        // lấy dữ liệu trên url
        getDataFormUrl();
        // hiển thị dữ liệu lên form
        loadPlayerToForm()
        // gọi aPI
        callApiPlayerDiceHistory()

    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

    function getDataFormUrl() {
        var vNewUrl = new URL(window.location.href)

        gVoucherInfoOjb.username = vNewUrl.searchParams.get("username")
        gVoucherInfoOjb.firstname = vNewUrl.searchParams.get("firstname")
        gVoucherInfoOjb.lastname = vNewUrl.searchParams.get("lastname")
    }

    // hàm load dữ liệu lên form
    function loadPlayerToForm() {
        $("#inp-username").val(gVoucherInfoOjb.username)
        $("#inp-firstname").val(gVoucherInfoOjb.firstname)
        $("#inp-lastname").val(gVoucherInfoOjb.lastname)
    }

    // gọi aPI
    function callApiPlayerDiceHistory() {
        $.ajax({
            url: baseUrl + "/voucher-history?username=" + gVoucherInfoOjb.username,
            type: "GET",
            success: function (paramOjb) {
                console.log(paramOjb)

                if (paramOjb.vouchers.length > 0) {
                    var vCount = 0
                    while (vCount < paramOjb.vouchers.length) {
                        var bDice = {
                            game: vCount,
                            maVoucher: paramOjb.vouchers[vCount].maVoucher,
                            phanTramGiamGia: paramOjb.vouchers[vCount].phanTramGiamGia,
                            ngayTao: paramOjb.vouchers[vCount].ngayTao,

                        }
                        gVoucherHistory.push(bDice)
                        vCount++
                    }
                    loadDataToTable(gVoucherHistory)
                }
            },
            error: function (paramErr) {
                console.log(paramErr.status)
            }
        })
    }

    // hàm load Dữ liệu lên bảng 
    function loadDataToTable(paramDice) {
        console.log(paramDice)
        gDataTable.clear()
        gDataTable.rows.add(paramDice)
        gDataTable.draw()
    }
</script>

</html>